diff --git a/kdeui/itemviews/kcategorizedview.cpp b/kdeui/itemviews/kcategorizedview.cpp
index 4b30859..005102a 100644
--- a/kdeui/itemviews/kcategorizedview.cpp
+++ b/kdeui/itemviews/kcategorizedview.cpp
@@ -544,937 +384,722 @@ KCategorizedView::~KCategorizedView()
     delete d;
 }
 
-void KCategorizedView::setGridSize(const QSize &size)
-{
-    QListView::setGridSize(size);
-
-    d->layoutChanged(true);
-}
-
 void KCategorizedView::setModel(QAbstractItemModel *model)
 {
-    d->lastSelection = QItemSelection();
-    d->forcedSelectionPosition = 0;
-    d->elementsInfo.clear();
-    d->elementsPosition.clear();
-    d->categoriesIndexes.clear();
-    d->categoriesPosition.clear();
-    d->categories.clear();
-    d->intersectedIndexes.clear();
-    d->modelIndexList.clear();
-    d->hovered = QModelIndex();
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
-
-    if (d->proxyModel)
-    {
-        QObject::disconnect(d->proxyModel,
-                            SIGNAL(layoutChanged()),
-                            this, SLOT(slotLayoutChanged()));
-
-        QObject::disconnect(d->proxyModel,
-                            SIGNAL(rowsRemoved(QModelIndex,int,int)),
-                            this, SLOT(rowsRemoved(QModelIndex,int,int)));
+    if (d->proxyModel == model) {
+        return;
     }
 
-    QListView::setModel(model);
+    d->blocks.clear();
+
+    if (d->proxyModel) {
+        disconnect(d->proxyModel, SIGNAL(layoutChanged()), this, SLOT(slotLayoutChanged()));
+    }
 
     d->proxyModel = dynamic_cast<KCategorizedSortFilterProxyModel*>(model);
 
-    if (d->proxyModel)
-    {
-        d->modelSortRole = d->proxyModel->sortRole();
-        d->modelSortColumn = d->proxyModel->sortColumn();
-        d->modelSortOrder = d->proxyModel->sortOrder();
-        d->modelLastRowCount = d->proxyModel->rowCount();
-        d->modelCategorized = d->proxyModel->isCategorizedModel();
-
-        QObject::connect(d->proxyModel,
-                         SIGNAL(layoutChanged()),
-                         this, SLOT(slotLayoutChanged()));
-
-        QObject::connect(d->proxyModel,
-                         SIGNAL(rowsRemoved(QModelIndex,int,int)),
-                         this, SLOT(rowsRemoved(QModelIndex,int,int)));
-
-        if (d->proxyModel->rowCount())
-        {
-            d->layoutChanged(true);
-        }
+    if (d->proxyModel) {
+        connect(d->proxyModel, SIGNAL(layoutChanged()), this, SLOT(slotLayoutChanged()));
     }
-    else
-    {
-        d->modelCategorized = false;
+
+    QListView::setModel(model);
+
+    // if the model already had information inserted, update our data structures to it
+    if (model->rowCount()) {
+        slotLayoutChanged();
     }
 }
 
+void KCategorizedView::setGridSize(const QSize &size)
+{
+    d->regenerateAllElements();
+    QListView::setGridSize(size);
+}
+
+// TODO: make difference depending on viewMode: ListMode or IconMode.
 QRect KCategorizedView::visualRect(const QModelIndex &index) const
 {
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
+    if (!d->isCategorized()) {
         return QListView::visualRect(index);
     }
 
-    if (!qobject_cast<const QSortFilterProxyModel*>(index.model()))
-    {
-        return d->visualRect(d->proxyModel->mapFromSource(index));
+    if (!index.isValid()) {
+        return QRect();
     }
 
-    return d->visualRect(index);
-}
+    const QString category = d->categoryForIndex(index);
 
-KCategoryDrawer *KCategorizedView::categoryDrawer() const
-{
-    return d->categoryDrawer;
-}
+    if (!d->blocks.contains(category)) {
+        return QRect();
+    }
 
-void KCategorizedView::setCategoryDrawer(KCategoryDrawer *categoryDrawer)
-{
-    d->lastSelection = QItemSelection();
-    d->forcedSelectionPosition = 0;
-    d->elementsInfo.clear();
-    d->elementsPosition.clear();
-    d->categoriesIndexes.clear();
-    d->categoriesPosition.clear();
-    d->categories.clear();
-    d->intersectedIndexes.clear();
-    d->modelIndexList.clear();
-    d->hovered = QModelIndex();
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
-
-    if (!categoryDrawer && d->proxyModel)
-    {
-        QObject::disconnect(d->proxyModel,
-                            SIGNAL(layoutChanged()),
-                            this, SLOT(slotLayoutChanged()));
+    Private::Block &block = d->blocks[category];
+    int firstIndexRow = block.firstIndex.row();
 
-        QObject::disconnect(d->proxyModel,
-                            SIGNAL(rowsRemoved(QModelIndex,int,int)),
-                            this, SLOT(rowsRemoved(QModelIndex,int,int)));
-    }
-    else if (categoryDrawer && d->proxyModel)
-    {
-        QObject::connect(d->proxyModel,
-                         SIGNAL(layoutChanged()),
-                         this, SLOT(slotLayoutChanged()));
+    Q_ASSERT(block.firstIndex.isValid());
 
-        QObject::connect(d->proxyModel,
-                         SIGNAL(rowsRemoved(QModelIndex,int,int)),
-                         this, SLOT(rowsRemoved(QModelIndex,int,int)));
+    if (index.row() - firstIndexRow < 0 || index.row() - firstIndexRow >= block.items.count()) {
+        return QRect();
     }
 
-    d->categoryDrawer = categoryDrawer;
+    const QPoint blockPos = d->blockPosition(category);
+
+    Private::Item &ritem = block.items[index.row() - firstIndexRow];
+
+    if (ritem.topLeft.isNull() || (block.quarantineStart.isValid() &&
+                                   index.row() >= block.quarantineStart.row())) {
+        if (d->hasGrid()) {
+            const int relativeRow = index.row() - firstIndexRow;
+            const int maxItemsPerRow = qMax(d->viewportWidth() / gridSize().width(), 1);
+            ritem.topLeft.rx() = (relativeRow % maxItemsPerRow) * gridSize().width() + blockPos.x() + d->categoryDrawer->leftMargin();
+            ritem.topLeft.ry() = (relativeRow / maxItemsPerRow) * gridSize().height();
+        } else {
+            if (uniformItemSizes()) {
+                const int relativeRow = index.row() - firstIndexRow;
+                const QSize itemSize = sizeHintForIndex(index);
+                const int maxItemsPerRow = qMax((d->viewportWidth() - spacing()) / (itemSize.width() + spacing()), 1);
+                ritem.topLeft.rx() = (relativeRow % maxItemsPerRow) * itemSize.width() + blockPos.x() + d->categoryDrawer->leftMargin();
+                ritem.topLeft.ry() = (relativeRow / maxItemsPerRow) * itemSize.height();
+            } else {
+                if (index != block.firstIndex) {
+                    const int viewportWidth = d->viewportWidth() - spacing();
+                    QModelIndex prevIndex = d->proxyModel->index(index.row() - 1, modelColumn(), rootIndex());
+                    QRect prevRect = visualRect(prevIndex);
+                    prevRect = d->mapFromViewport(prevRect);
+                    const QSize currSize = sizeHintForIndex(index);
+                    if ((prevRect.bottomRight().x() + 1) + currSize.width() - blockPos.x() + spacing()  > viewportWidth) {
+                        // we have to check the whole previous row, and see which one was the
+                        // highest.
+                        Q_FOREVER {
+                            prevIndex = d->proxyModel->index(prevIndex.row() - 1, modelColumn(), rootIndex());
+                            const QRect tempRect = visualRect(prevIndex);
+                            if (tempRect.topLeft().y() < prevRect.topLeft().y()) {
+                                break;
+                            }
+                            if (tempRect.bottomRight().y() > prevRect.bottomRight().y()) {
+                                prevRect = tempRect;
+                            }
+                            if (prevIndex == block.firstIndex) {
+                                break;
+                            }
+                        }
+                        ritem.topLeft.rx() = d->categoryDrawer->leftMargin() + blockPos.x() + spacing();
+                        ritem.topLeft.ry() = (prevRect.bottomRight().y() + 1) + spacing() - blockPos.y();
+                    } else {
+                        ritem.topLeft.rx() = (prevRect.bottomRight().x() + 1) + spacing();
+                        ritem.topLeft.ry() = prevRect.topLeft().y() - blockPos.y();
+                    }
+                } else {
+                    ritem.topLeft.rx() = blockPos.x() + d->categoryDrawer->leftMargin() + spacing();
+                    ritem.topLeft.ry() = spacing();
+                }
+            }
+        }
 
-    if (categoryDrawer)
-    {
-        if (d->proxyModel)
-        {
-            if (d->proxyModel->rowCount())
-            {
-                d->layoutChanged(true);
+        //TODO: update this cached size if the delegate emits sizeHintChanged
+        ritem.size = sizeHintForIndex(index);
+
+        //BEGIN: update the quarantine start
+        const bool wasLastIndex = (index.row() == (block.firstIndex.row() + block.items.count() - 1));
+        if (index.row() == block.quarantineStart.row()) {
+            if (wasLastIndex) {
+                block.quarantineStart = QModelIndex();
+            } else {
+                const QModelIndex nextIndex = d->proxyModel->index(index.row() + 1, modelColumn(), rootIndex());
+                block.quarantineStart = nextIndex;
             }
         }
+        //END: update the quarantine start
+    }
+
+    // we get now the absolute position through the relative position of the parent block. do not
+    // save this on ritem, since this would override the item relative position in block terms.
+    Private::Item item(ritem);
+    item.topLeft.ry() += blockPos.y();
+
+    const QSize sizeHint = item.size;
+
+    if (d->hasGrid()) {
+        const QSize sizeGrid = gridSize();
+        const QSize resultingSize = sizeHint.boundedTo(sizeGrid);
+        QRect res(item.topLeft.x() + ((sizeGrid.width() - resultingSize.width()) / 2),
+                  item.topLeft.y(), resultingSize.width(), resultingSize.height());
+        //NOTE: think of using isRowHidden and setRowHidden methods
+        if (block.collapsed) {
+            // we can still do binary search, while we "hide" items. We move those items in collapsed
+            // blocks to the left and set a 0 height.
+            res.setLeft(-resultingSize.width());
+            res.setHeight(0);
+        }
+        return d->mapToViewport(res);
     }
-    else
-    {
-        updateGeometries();
+
+    QRect res(item.topLeft.x(), item.topLeft.y(), sizeHint.width(), sizeHint.height());
+    //NOTE: think of using isRowHidden and setRowHidden methods
+    if (block.collapsed) {
+        // we can still do binary search, while we "hide" items. We move those items in collapsed
+        // blocks to the left and set a 0 height.
+        res.setLeft(-sizeHint.width());
+        res.setHeight(0);
     }
+    return d->mapToViewport(res);
 }
 
-QModelIndex KCategorizedView::indexAt(const QPoint &point) const
+KCategoryDrawer *KCategorizedView::categoryDrawer() const
 {
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        return QListView::indexAt(point);
-    }
+    return d->categoryDrawer;
+}
 
-    QModelIndex index;
+void KCategorizedView::setCategoryDrawer(KCategoryDrawer *categoryDrawer)
+{
+    if (d->categoryDrawerV2) {
+        disconnect(d->categoryDrawerV2, SIGNAL(collapseOrExpandClicked(QModelIndex)),
+                   this, SLOT(_k_slotCollapseOrExpandClicked(QModelIndex)));
+    }
 
-    const QModelIndexList item = d->intersectionSet(QRect(point, point));
+    d->categoryDrawer = categoryDrawer;
+    d->categoryDrawerV2 = dynamic_cast<KCategoryDrawerV2*>(categoryDrawer);
 
-    if (item.count() == 1)
-    {
-        index = item[0];
+    if (d->categoryDrawerV2) {
+        connect(d->categoryDrawerV2, SIGNAL(collapseOrExpandClicked(QModelIndex)),
+                this, SLOT(_k_slotCollapseOrExpandClicked(QModelIndex)));
     }
-
-    return index;
 }
 
-void KCategorizedView::reset()
+int KCategorizedView::categorySpacing() const
 {
-    QListView::reset();
-
-    d->lastSelection = QItemSelection();
-    d->forcedSelectionPosition = 0;
-    d->elementsInfo.clear();
-    d->elementsPosition.clear();
-    d->categoriesIndexes.clear();
-    d->categoriesPosition.clear();
-    d->categories.clear();
-    d->intersectedIndexes.clear();
-    d->modelIndexList.clear();
-    d->hovered = QModelIndex();
-    d->biggestItemSize = QSize(0, 0);
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
+    return d->categorySpacing;
 }
 
-void KCategorizedView::paintEvent(QPaintEvent *event)
+void KCategorizedView::setCategorySpacing(int categorySpacing)
 {
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        QListView::paintEvent(event);
+    if (d->categorySpacing == categorySpacing) {
         return;
     }
 
-    bool alternatingRows = alternatingRowColors();
-
-    QStyleOptionViewItemV4 option = viewOptions();
-    option.widget = this;
-    if (wordWrap())
-    {
-        option.features |= QStyleOptionViewItemV4::WrapText;
-    }
-
-    QPainter painter(viewport());
-    QRect area = event->rect();
-    const bool focus = (hasFocus() || viewport()->hasFocus()) &&
-                        currentIndex().isValid();
-    const QStyle::State state = option.state;
-    const bool enabled = (state & QStyle::State_Enabled) != 0;
+    d->categorySpacing = categorySpacing;
 
-    painter.save();
-
-    QModelIndexList dirtyIndexes = d->intersectionSet(area);
-    bool alternate = false;
-    if (dirtyIndexes.count())
-    {
-        alternate = dirtyIndexes[0].row() % 2;
+    for (QHash<QString, Private::Block>::Iterator it = d->blocks.begin(); it != d->blocks.end(); ++it) {
+        Private::Block &block = *it;
+        block.outOfQuarantine = false;
     }
-    foreach (const QModelIndex &index, dirtyIndexes)
-    {
-        if (alternatingRows && alternate)
-        {
-            option.features |= QStyleOptionViewItemV4::Alternate;
-            alternate = false;
-        }
-        else if (alternatingRows)
-        {
-            option.features &= ~QStyleOptionViewItemV4::Alternate;
-            alternate = true;
-        }
-        option.state = state;
-        option.rect = visualRect(index);
+}
 
-        if (selectionModel() && selectionModel()->isSelected(index))
-        {
-            option.state |= QStyle::State_Selected;
-        }
+bool KCategorizedView::alternatingBlockColors() const
+{
+    return d->alternatingBlockColors;
+}
 
-        if (enabled)
-        {
-            QPalette::ColorGroup cg;
-            if ((d->proxyModel->flags(index) & Qt::ItemIsEnabled) == 0)
-            {
-                option.state &= ~QStyle::State_Enabled;
-                cg = QPalette::Disabled;
-            }
-            else
-            {
-                cg = QPalette::Normal;
-            }
-            option.palette.setCurrentColorGroup(cg);
-        }
+void KCategorizedView::setAlternatingBlockColors(bool enable)
+{
+    d->alternatingBlockColors = enable;
+}
 
-        if (focus && currentIndex() == index)
-        {
-            option.state |= QStyle::State_HasFocus;
-            if (this->state() == EditingState)
-                option.state |= QStyle::State_Editing;
-        }
+bool KCategorizedView::collapsibleBlocks() const
+{
+    return d->collapsibleBlocks;
+}
 
-        if (index == d->hovered)
-            option.state |= QStyle::State_MouseOver;
-        else
-            option.state &= ~QStyle::State_MouseOver;
+void KCategorizedView::setCollapsibleBlocks(bool enable)
+{
+    d->collapsibleBlocks = enable;
+}
 
-        itemDelegate(index)->paint(&painter, option, index);
+QModelIndex KCategorizedView::indexAt(const QPoint &point) const
+{
+    if (!d->isCategorized()) {
+        return QListView::indexAt(point);
     }
 
-    // Redraw categories
-    QStyleOptionViewItemV4 otherOption;
-    bool intersectedInThePast = false;
-    foreach (const QString &category, d->categories)
-    {
-        otherOption = option;
-        otherOption.rect = d->categoryVisualRect(category);
-        otherOption.state &= ~QStyle::State_MouseOver;
-
-        if (otherOption.rect.intersects(area))
-        {
-            intersectedInThePast = true;
-
-            QModelIndex indexToDraw = d->proxyModel->index(d->categoriesIndexes[category][0].row(), d->proxyModel->sortColumn());
+    const int rowCount = d->proxyModel->rowCount();
+    if (!rowCount) {
+        return QModelIndex();
+    }
 
-            d->drawNewCategory(indexToDraw,
-                               d->proxyModel->sortRole(), otherOption, &painter);
+    // Binary search that will try to spot if there is an index under point
+    int bottom = 0;
+    int top = rowCount - 1;
+    while (bottom <= top) {
+        const int middle = (bottom + top) / 2;
+        const QModelIndex index = d->proxyModel->index(middle, modelColumn(), rootIndex());
+        QRect rect = visualRect(index);
+        const int verticalOff = verticalOffset();
+        const int horizontalOff = horizontalOffset();
+        rect.topLeft().ry() += verticalOff;
+        rect.topLeft().rx() += horizontalOff;
+        rect.bottomRight().ry() += verticalOff;
+        rect.bottomRight().rx() += horizontalOff;
+        if (rect.contains(point)) {
+            return index;
         }
-        else if (intersectedInThePast)
-        {
-            break; // the visible area has been finished, we don't need to keep asking, the rest won't intersect
-                // this is doable because we know that categories are correctly ordered on the list
+        if (point.y() > rect.bottomRight().y() ||
+            (point.y() > rect.topLeft().y() && point.y() < rect.bottomRight().y() &&
+             point.x() > rect.bottomRight().x())) {
+            bottom = middle + 1;
+        } else {
+            top = middle - 1;
         }
     }
 
-    if ((selectionMode() != SingleSelection) && (selectionMode() != NoSelection))
-    {
-        if (d->mouseButtonPressed && !d->isDragging)
-        {
-            QPoint start, end, initialPressPosition;
+    return QModelIndex();
+}
 
-            initialPressPosition = d->initialPressPosition;
+void KCategorizedView::reset()
+{
+    d->blocks.clear();
+    QListView::reset();
+}
 
-            initialPressPosition.setY(initialPressPosition.y() - verticalOffset());
-            initialPressPosition.setX(initialPressPosition.x() - horizontalOffset());
+void KCategorizedView::paintEvent(QPaintEvent *event)
+{
+    if (!d->isCategorized()) {
+        QListView::paintEvent(event);
+        return;
+    }
 
-            if (d->initialPressPosition.x() > d->mousePosition.x() ||
-                d->initialPressPosition.y() > d->mousePosition.y())
-            {
-                start = d->mousePosition;
-                end = initialPressPosition;
-            }
-            else
-            {
-                start = initialPressPosition;
-                end = d->mousePosition;
+    const QPair<QModelIndex, QModelIndex> intersecting = d->intersectingIndexesWithRect(viewport()->rect().intersected(event->rect()));
+
+    QPainter p(viewport());
+    p.save();
+
+    Q_ASSERT(selectionModel()->model() == d->proxyModel);
+
+    //BEGIN: draw categories
+    QHash<QString, Private::Block>::ConstIterator it(d->blocks.constBegin());
+    while (it != d->blocks.constEnd()) {
+        const Private::Block &block = *it;
+        const QModelIndex categoryIndex = d->proxyModel->index(block.firstIndex.row(), d->proxyModel->sortColumn(), rootIndex());
+        QStyleOptionViewItemV4 option(viewOptions());
+        option.features |= d->alternatingBlockColors && block.alternate ? QStyleOptionViewItemV4::Alternate
+                                                                        : QStyleOptionViewItemV4::None;
+        option.state |= !d->collapsibleBlocks || !block.collapsed ? QStyle::State_Open
+                                                                  : QStyle::State_None;
+        const int height = d->categoryDrawer->categoryHeight(categoryIndex, option);
+        QPoint pos = d->blockPosition(it.key());
+        pos.ry() -= height;
+        option.rect.setTopLeft(pos);
+        option.rect.setWidth(d->viewportWidth() + d->categoryDrawer->leftMargin() + d->categoryDrawer->rightMargin());
+        option.rect.setHeight(height + d->blockHeight(it.key()));
+        option.rect = d->mapToViewport(option.rect);
+        if (!option.rect.intersects(viewport()->rect())) {
+            ++it;
+            continue;
+        }
+        d->categoryDrawer->drawCategory(categoryIndex, d->proxyModel->sortRole(), option, &p);
+        ++it;
+    }
+    //END: draw categories
+
+    if (intersecting.first.isValid() && intersecting.second.isValid()) {
+        //BEGIN: draw items
+        int i = intersecting.first.row();
+        int indexToCheckIfBlockCollapsed = i;
+        while (i <= intersecting.second.row()) {
+            //BEGIN: first check if the block is collapsed. if so, we have to skip the item painting
+            if (i == indexToCheckIfBlockCollapsed) {
+                const QModelIndex categoryIndex = d->proxyModel->index(i, d->proxyModel->sortColumn(), rootIndex());
+                const QString category = categoryIndex.data(KCategorizedSortFilterProxyModel::CategoryDisplayRole).toString();
+                const Private::Block &block = d->blocks[category];
+                indexToCheckIfBlockCollapsed = block.firstIndex.row() + block.items.count();
+                if (block.collapsed) {
+                    i = indexToCheckIfBlockCollapsed;
+                    continue;
+                }
             }
-
-            QStyleOptionRubberBand yetAnotherOption;
-            yetAnotherOption.initFrom(this);
-            yetAnotherOption.shape = QRubberBand::Rectangle;
-            yetAnotherOption.opaque = false;
-            yetAnotherOption.rect = QRect(start, end).intersected(viewport()->rect().adjusted(-16, -16, 16, 16));
-            painter.save();
-            style()->drawControl(QStyle::CE_RubberBand, &yetAnotherOption, &painter);
-            painter.restore();
+            //END: first check if the block is collapsed. if so, we have to skip the item painting
+
+            const QModelIndex index = d->proxyModel->index(i, modelColumn(), rootIndex());
+            QStyleOptionViewItemV4 option(viewOptions());
+            option.rect = visualRect(index);
+            option.widget = this;
+            option.features |= wordWrap() ? QStyleOptionViewItemV2::WrapText
+                                        : QStyleOptionViewItemV2::None;
+            option.state |= (index == d->hoveredIndex) ? QStyle::State_MouseOver
+                                                    : QStyle::State_None;
+            option.state |= selectionModel()->isSelected(index) ? QStyle::State_Selected
+                                                                : QStyle::State_None;
+            option.state |= (index == currentIndex()) ? QStyle::State_HasFocus
+                                                    : QStyle::State_None;
+            itemDelegate(index)->paint(&p, option, index);
+            ++i;
         }
+        //END: draw items
     }
 
-    if (d->isDragging && !d->dragLeftViewport)
-    {
-        painter.setOpacity(0.5);
-        d->drawDraggedItems(&painter);
+    //BEGIN: draw selection rect
+    if (isSelectionRectVisible() && d->rubberBandRect.isValid()) {
+        QStyleOptionRubberBand opt;
+        opt.initFrom(this);
+        opt.shape = QRubberBand::Rectangle;
+        opt.opaque = false;
+        opt.rect = d->mapToViewport(d->rubberBandRect).intersected(viewport()->rect().adjusted(-16, -16, 16, 16));
+        p.save();
+        style()->drawControl(QStyle::CE_RubberBand, &opt, &p);
+        p.restore();
     }
+    //END: draw selection rect
 
-    painter.restore();
+    p.restore();
 }
 
 void KCategorizedView::resizeEvent(QResizeEvent *event)
 {
+    d->regenerateAllElements();
     QListView::resizeEvent(event);
-
-    // Clear the items positions cache
-    d->elementsPosition.clear();
-    d->categoriesPosition.clear();
-    d->forcedSelectionPosition = 0;
-
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        return;
-    }
-
-    d->updateScrollbars();
 }
 
 void KCategorizedView::setSelection(const QRect &rect,
                                     QItemSelectionModel::SelectionFlags flags)
 {
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
+    if (!d->isCategorized()) {
         QListView::setSelection(rect, flags);
         return;
     }
 
-    if (!flags)
+    if (rect.topLeft() == rect.bottomRight()) {
+        const QModelIndex index = indexAt(rect.topLeft());
+        selectionModel()->select(index, flags);
         return;
-
-    if (flags & QItemSelectionModel::Clear)
-    {
-        selectionModel()->clear();
-        d->lastSelection.clear();
     }
 
-    QModelIndexList dirtyIndexes = d->intersectionSet(rect);
+    const QPair<QModelIndex, QModelIndex> intersecting = d->intersectingIndexesWithRect(rect);
 
-    // no items affected, just leave
-    if (!dirtyIndexes.count())
-    {
-        selectionModel()->select(d->lastSelection, QItemSelectionModel::SelectCurrent);
+    QItemSelection selection;
 
-        return;
-    }
-
-    QModelIndex topLeft;
-    QModelIndex bottomRight;
-
-    if (d->mouseButtonPressed || d->rightMouseButtonPressed) // selection with click + drag
-    {
-        QItemSelection selection;
-
-        QModelIndex prev = dirtyIndexes[0];
-        QModelIndex first = prev;
-        foreach (const QModelIndex &index, dirtyIndexes)
-        {
-            // we have a different interval. non-contiguous items
-            if ((index.row() - prev.row()) > 1) {
-                selection << QItemSelectionRange(first, prev);
-
-                first = index;
-            }
-
-            prev = index;
-        }
-
-        selection << QItemSelectionRange(first, prev);
-
-        if (flags & QItemSelectionModel::Current)
-        {
-            if (rect.topLeft() == rect.bottomRight())
-            {
-                selectionModel()->setCurrentIndex(indexAt(rect.topLeft()), QItemSelectionModel::NoUpdate);
+    //TODO: think of a faster implementation
+    QModelIndex firstIndex;
+    QModelIndex lastIndex;
+    for (int i = intersecting.first.row(); i <= intersecting.second.row(); ++i) {
+        const QModelIndex index = d->proxyModel->index(i, modelColumn(), rootIndex());
+        const bool visualRectIntersects = visualRect(index).intersects(rect);
+        if (firstIndex.isValid()) {
+            if (visualRectIntersects) {
+                lastIndex = index;
+            } else {
+                selection << QItemSelectionRange(firstIndex, lastIndex);
+                firstIndex = QModelIndex();
             }
-
-            selection.merge(d->lastSelection, flags);
-        }
-        else
-        {
-            selection.merge(selectionModel()->selection(), flags);
-
-            selectionModel()->select(selection, QItemSelectionModel::SelectCurrent);
-
-            return;
+        } else if (visualRectIntersects) {
+            firstIndex = index;
+            lastIndex = index;
         }
-
-        selectionModel()->select(selection, flags);
     }
-    else // selection with click + keyboard keys
-    {
-        QModelIndex topLeftIndex = indexAt(QPoint(rect.topLeft().x(),
-                                                  rect.topLeft().y()));
-        QModelIndex bottomRightIndex = indexAt(QPoint(rect.bottomRight().x(),
-                                                      rect.bottomRight().y()));
-
-        // keyboard selection comes "upside down". Let's normalize it
-        if (topLeftIndex.row() > bottomRightIndex.row())
-        {
-            QModelIndex auxIndex = topLeftIndex;
-            topLeftIndex = bottomRightIndex;
-            bottomRightIndex = auxIndex;
-        }
-
-        int viewportWidth = viewport()->width() - spacing();
-        int itemWidth;
-
-        if (gridSize().isEmpty())
-        {
-            itemWidth = d->biggestItemSize.width();
-        }
-        else
-        {
-            itemWidth = gridSize().width();
-        }
-
-        int itemWidthPlusSeparation = spacing() + itemWidth;
-        if (!itemWidthPlusSeparation)
-            itemWidthPlusSeparation++;
-        int elementsPerRow = viewportWidth / itemWidthPlusSeparation;
-        if (!elementsPerRow)
-            elementsPerRow++;
-
-        QModelIndexList theoricDirty(dirtyIndexes);
-        dirtyIndexes.clear();
-        int first = model()->rowCount();
-        int last = 0;
-
-        foreach (const QModelIndex &index, theoricDirty)
-        {
-            if ((index.row() < first) &&
-                ((((topLeftIndex.row() / elementsPerRow) == (index.row() / elementsPerRow)) &&
-                  ((topLeftIndex.row() % elementsPerRow) <= (index.row() % elementsPerRow))) ||
-                 (topLeftIndex.row() / elementsPerRow) != (index.row() / elementsPerRow)))
-            {
-                first = index.row();
-                topLeft = index;
-            }
-
-            if ((index.row() > last) &&
-                ((((bottomRightIndex.row() / elementsPerRow) == (index.row() / elementsPerRow)) &&
-                  ((bottomRightIndex.row() % elementsPerRow) >= (index.row() % elementsPerRow))) ||
-                 (bottomRightIndex.row() / elementsPerRow) != (index.row() / elementsPerRow)))
-            {
-                last = index.row();
-                bottomRight = index;
-            }
-        }
 
-        for (int i = first; i <= last; i++)
-        {
-            dirtyIndexes << model()->index(i, theoricDirty[0].column(), theoricDirty[0].parent());
-        }
-
-        QItemSelection selection(topLeft, bottomRight);
-
-        selectionModel()->select(selection, flags);
+    if (firstIndex.isValid()) {
+        selection << QItemSelectionRange(firstIndex, lastIndex);
     }
+
+    selectionModel()->select(selection, flags);
 }
 
 void KCategorizedView::mouseMoveEvent(QMouseEvent *event)
 {
     QListView::mouseMoveEvent(event);
 
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        return;
-    }
-
-    const QModelIndexList item = d->intersectionSet(QRect(event->pos(), event->pos()));
-
-    if (item.count() == 1)
-    {
-        d->hovered = item[0];
-    }
-    else
-    {
-        d->hovered = QModelIndex();
-    }
-
-    const QString previousHoveredCategory = d->hoveredCategory;
-
-    d->mousePosition = event->pos();
-    d->hoveredCategory.clear();
-
-    // Redraw categories
-    foreach (const QString &category, d->categories)
-    {
-        if (d->categoryVisualRect(category).intersects(QRect(event->pos(), event->pos())))
-        {
-            d->hoveredCategory = category;
-            viewport()->update(d->categoryVisualRect(category));
-        }
-        else if ((category == previousHoveredCategory) &&
-                 (!d->categoryVisualRect(previousHoveredCategory).intersects(QRect(event->pos(), event->pos()))))
-        {
-            viewport()->update(d->categoryVisualRect(category));
-        }
-    }
+    d->hoveredIndex = indexAt(event->pos());
 
-    QRect rect;
-    if (d->mouseButtonPressed && !d->isDragging)
-    {
-        QPoint start, end, initialPressPosition;
-
-        initialPressPosition = d->initialPressPosition;
-
-        initialPressPosition.setY(initialPressPosition.y() - verticalOffset());
-        initialPressPosition.setX(initialPressPosition.x() - horizontalOffset());
-
-        if (d->initialPressPosition.x() > d->mousePosition.x() ||
-            d->initialPressPosition.y() > d->mousePosition.y())
-        {
-            start = d->mousePosition;
-            end = initialPressPosition;
-        }
-        else
-        {
-            start = initialPressPosition;
-            end = d->mousePosition;
-        }
+    const SelectionMode itemViewSelectionMode = selectionMode();
 
-        rect = QRect(start, end).adjusted(-16, -16, 16, 16);
-        rect = rect.united(QRect(start, end).adjusted(16, 16, -16, -16)).intersected(viewport()->rect());
-
-        viewport()->update(rect);
+    if (state() == DragSelectingState && isSelectionRectVisible() && itemViewSelectionMode != SingleSelection
+        && itemViewSelectionMode != NoSelection) {
+        QRect rect(d->pressedPosition, event->pos() + QPoint(horizontalOffset(), verticalOffset()));
+        rect = rect.normalized();
+        update(rect.united(d->rubberBandRect));
+        d->rubberBandRect = rect;
     }
 }
 
 void KCategorizedView::mousePressEvent(QMouseEvent *event)
 {
-    d->dragLeftViewport = false;
-
-    if (event->button() == Qt::LeftButton)
-    {
-        d->mouseButtonPressed = true;
-
-        d->initialPressPosition = event->pos();
-        d->initialPressPosition.setY(d->initialPressPosition.y() +
-                                                              verticalOffset());
-        d->initialPressPosition.setX(d->initialPressPosition.x() +
-                                                            horizontalOffset());
-    }
-    else if (event->button() == Qt::RightButton)
-    {
-        d->rightMouseButtonPressed = true;
-    }
-
     QListView::mousePressEvent(event);
-
-    if (selectionModel())
-    {
-        d->lastSelection = selectionModel()->selection();
+    if (event->button() == Qt::LeftButton) {
+        d->pressedPosition = event->pos();
+        d->pressedPosition.rx() += horizontalOffset();
+        d->pressedPosition.ry() += verticalOffset();
     }
-
-    viewport()->update(d->categoryVisualRect(d->hoveredCategory));
 }
 
 void KCategorizedView::mouseReleaseEvent(QMouseEvent *event)
 {
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
-
     QListView::mouseReleaseEvent(event);
-
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        return;
-    }
-
-    QPoint initialPressPosition = viewport()->mapFromGlobal(QCursor::pos());
-    initialPressPosition.setY(initialPressPosition.y() + verticalOffset());
-    initialPressPosition.setX(initialPressPosition.x() + horizontalOffset());
-
-    if ((selectionMode() != SingleSelection) && (selectionMode() != NoSelection) &&
-        (initialPressPosition == d->initialPressPosition))
-    {
-        foreach(const QString &category, d->categories)
-        {
-            if (d->categoryVisualRect(category).contains(event->pos()) &&
-                selectionModel())
-            {
-                QItemSelection selection = selectionModel()->selection();
-                QModelIndexList indexList = d->categoriesIndexes[category];
-
-                foreach (const QModelIndex &index, indexList)
-                {
-                    QModelIndex selectIndex = index.model()->index(index.row(), 0);
-
-                    selection << QItemSelectionRange(selectIndex);
-                }
-
-                selectionModel()->select(selection, QItemSelectionModel::SelectCurrent);
-
-                break;
-            }
-        }
-    }
-
-    QRect rect;
-    if (!d->isDragging)
-    {
-        QPoint start, end, initialPressPosition;
-
-        initialPressPosition = d->initialPressPosition;
-
-        initialPressPosition.setY(initialPressPosition.y() - verticalOffset());
-        initialPressPosition.setX(initialPressPosition.x() - horizontalOffset());
-
-        if (d->initialPressPosition.x() > d->mousePosition.x() ||
-            d->initialPressPosition.y() > d->mousePosition.y())
-        {
-            start = d->mousePosition;
-            end = initialPressPosition;
-        }
-        else
-        {
-            start = initialPressPosition;
-            end = d->mousePosition;
-        }
-
-        rect = QRect(start, end).adjusted(-16, -16, 16, 16);
-        rect = rect.united(QRect(start, end).adjusted(16, 16, -16, -16)).intersected(viewport()->rect());
-
-        viewport()->update(rect);
-    }
-
-    if (d->hovered.isValid())
-        viewport()->update(visualRect(d->hovered));
-    else if (!d->hoveredCategory.isEmpty())
-        viewport()->update(d->categoryVisualRect(d->hoveredCategory));
+    d->pressedPosition = QPoint();
+    d->rubberBandRect = QRect();
 }
 
 void KCategorizedView::leaveEvent(QEvent *event)
 {
-    d->hovered = QModelIndex();
-    d->hoveredCategory.clear();
-
     QListView::leaveEvent(event);
+
+    if (d->hoveredIndex.isValid()) {
+        viewport()->update(visualRect(d->hoveredIndex));
+        d->hoveredIndex = QModelIndex();
+    }
 }
 
 void KCategorizedView::startDrag(Qt::DropActions supportedActions)
 {
-    // FIXME: QAbstractItemView does far better here since it sets the
-    //        pixmap of selected icons to the dragging cursor, but it sets a non
-    //        ARGB window so it is no transparent. Use QAbstractItemView when
-    //        this is fixed on Qt.
-    // QAbstractItemView::startDrag(supportedActions);
-#if defined(DOLPHIN_DRAGANDDROP)
-    Q_UNUSED(supportedActions);
-#else
     QListView::startDrag(supportedActions);
-#endif
-
-    d->isDragging = false;
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
-
-    viewport()->update(d->lastDraggedItemsRect);
 }
 
 void KCategorizedView::dragMoveEvent(QDragMoveEvent *event)
 {
-    d->mousePosition = event->pos();
-
-    if (d->mouseButtonPressed)
-    {
-        d->isDragging = true;
-    }
-    else
-    {
-        d->isDragging = false;
-    }
-
-    d->dragLeftViewport = false;
-
-#if defined(DOLPHIN_DRAGANDDROP)
     QAbstractItemView::dragMoveEvent(event);
-#else
-    QListView::dragMoveEvent(event);
-#endif
-
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        return;
-    }
-    
-    d->hovered = indexAt(event->pos());
-
-#if !defined(DOLPHIN_DRAGANDDROP)
-    d->drawDraggedItems();
-#endif
 }
 
 void KCategorizedView::dragLeaveEvent(QDragLeaveEvent *event)
 {
-    d->dragLeftViewport = true;
-
-#if defined(DOLPHIN_DRAGANDDROP)
     QAbstractItemView::dragLeaveEvent(event);
-#else
-    QListView::dragLeaveEvent(event);
-#endif
 }
 
 void KCategorizedView::dropEvent(QDropEvent *event)
 {
-#if defined(DOLPHIN_DRAGANDDROP)
     QAbstractItemView::dropEvent(event);
-#else
-    QListView::dropEvent(event);
-#endif
 }
 
+//TODO: improve so we take into account isRowHidden in a better way
+//TODO: improve se we take into account collapsed blocks
 QModelIndex KCategorizedView::moveCursor(CursorAction cursorAction,
                                          Qt::KeyboardModifiers modifiers)
 {
-    if ((viewMode() != KCategorizedView::IconMode) ||
-        !d->proxyModel ||
-        !d->categoryDrawer ||
-         d->categories.isEmpty() ||
-        !d->proxyModel->isCategorizedModel())
-    {
+    if (!d->isCategorized()) {
         return QListView::moveCursor(cursorAction, modifiers);
     }
 
-    int viewportWidth = viewport()->width() - spacing();
-    int itemWidth;
-
-    if (gridSize().isEmpty())
-    {
-        itemWidth = d->biggestItemSize.width();
-    }
-    else
-    {
-        itemWidth = gridSize().width();
-    }
-
-    int itemWidthPlusSeparation = spacing() + itemWidth;
-    if (!itemWidthPlusSeparation)
-        itemWidthPlusSeparation++;
-    int elementsPerRow = viewportWidth / itemWidthPlusSeparation;
-    if (!elementsPerRow)
-        elementsPerRow++;
-
-    QModelIndex current = selectionModel() ? selectionModel()->currentIndex()
-                                           : QModelIndex();
-
-    if (!current.isValid())
-    {
-        if (cursorAction == MoveEnd)
-        {
-            current = model()->index(model()->rowCount() - 1, 0, QModelIndex());
-            d->forcedSelectionPosition = d->elementsInfo[current.row()].relativeOffsetToCategory % elementsPerRow;
+    const QModelIndex current = currentIndex();
+    const QRect currentRect = visualRect(current);
+    if (!current.isValid()) {
+        const int rowCount = d->proxyModel->rowCount(rootIndex());
+        if (!rowCount) {
+            return QModelIndex();
         }
-        else
-        {
-            current = model()->index(0, 0, QModelIndex());
-            d->forcedSelectionPosition = 0;
+        int row = 0;
+        while (row < rowCount && isRowHidden(row)) {
+            ++row;
         }
-
-        return current;
+        if (row >= rowCount) {
+            return QModelIndex();
+        }
+        return d->proxyModel->index(row, modelColumn(), rootIndex());
     }
 
-    QString lastCategory = d->categories.first();
-    QString theCategory = d->categories.first();
-    QString afterCategory = d->categories.first();
-
-    bool hasToBreak = false;
-    foreach (const QString &category, d->categories)
-    {
-        if (hasToBreak)
-        {
-            afterCategory = category;
-
+    switch (cursorAction) {
+        case MoveLeft: {
+                if (!current.row()) {
+                    return QModelIndex();
+                }
+                const QModelIndex previous = d->proxyModel->index(current.row() - 1, modelColumn(), rootIndex());
+                const QRect previousRect = visualRect(previous);
+                if (previousRect.top() == currentRect.top()) {
+                    return previous;
+                }
+                return QModelIndex();
+            }
+        case MoveRight: {
+                if (current.row() == d->proxyModel->rowCount() - 1) {
+                    return QModelIndex();
+                }
+                const QModelIndex next = d->proxyModel->index(current.row() + 1, modelColumn(), rootIndex());
+                const QRect nextRect = visualRect(next);
+                if (nextRect.top() == currentRect.top()) {
+                    return next;
+                }
+                return QModelIndex();
+            }
+        case MoveDown: {
+                if (d->hasGrid()) {
+                    const int maxItemsPerRow = qMax(d->viewportWidth() / gridSize().width(), 1);
+                    if (current.row() + maxItemsPerRow > d->proxyModel->rowCount()) {
+                        return QModelIndex();
+                    }
+                    
+                }
+            }
+        default:
             break;
-        }
+    }
 
-        if (category == d->elementsInfo[current.row()].category)
-        {
-            theCategory = category;
+    return QModelIndex();
+}
 
-            hasToBreak = true;
-        }
+void KCategorizedView::rowsAboutToBeRemoved(const QModelIndex &parent,
+                                            int start,
+                                            int end)
+{
+    if (!d->isCategorized()) {
+        QListView::rowsAboutToBeRemoved(parent, start, end);
+        return;
+    }
 
-        if (!hasToBreak)
-        {
-            lastCategory = category;
-        }
+    if (end - start + 1 == d->proxyModel->rowCount()) {
+        d->blocks.clear();
+        QListView::rowsAboutToBeRemoved(parent, start, end);
+        return;
     }
 
-    switch (cursorAction)
-    {
-        case QAbstractItemView::MoveUp: {
-            if (d->elementsInfo[current.row()].relativeOffsetToCategory >= elementsPerRow)
-            {
-                int indexToMove = current.row();
-                indexToMove -= qMin(((d->elementsInfo[current.row()].relativeOffsetToCategory) + d->forcedSelectionPosition), elementsPerRow - d->forcedSelectionPosition + (d->elementsInfo[current.row()].relativeOffsetToCategory % elementsPerRow));
+    // Removal feels a bit more complicated than insertion. Basically we can consider there are
+    // 3 different cases when going to remove items. (*) represents an item, Items between ([) and
+    // (]) are the ones which are marked for removal.
+    //
+    // - 1st case:
+    //              ... * * * * * * [ * * * ...
+    //
+    //   The items marked for removal are the last part of this category. No need to mark any item
+    //   of this category as in quarantine, because no special offset will be pushed to items at
+    //   the right because of any changes (since the removed items are those on the right most part
+    //   of the category).
+    //
+    // - 2nd case:
+    //              ... * * * * * * ] * * * ...
+    //
+    //   The items marked for removal are the first part of this category. We have to mark as in
+    //   quarantine all items in this category. Absolutely all. All items will have to be moved to
+    //   the left (or moving up, because rows got a different offset).
+    //
+    // - 3rd case:
+    //              ... * * [ * * * * ] * * ...
+    //
+    //   The items marked for removal are in between of this category. We have to mark as in
+    //   quarantine only those items that are at the right of the end of the removal interval,
+    //   (starting on "]").
+    //
+    // It hasn't been explicitly said, but when we remove, we have to mark all blocks that are
+    // located under the top most affected category as in quarantine (the block itself, as a whole),
+    // because such a change can force it to have a different offset (note that items themselves
+    // contain relative positions to the block, so marking the block as in quarantine is enough).
+    //
+    // Also note that removal implicitly means that we have to update correctly firstIndex of each
+    // block, and in general keep updated the internal information of elements.
+
+    QStringList listOfCategoriesMarkedForRemoval;
+
+    QString lastCategory;
+    int alreadyRemoved = 0;
+    for (int i = start; i <= end; ++i) {
+        const QModelIndex index = d->proxyModel->index(i, modelColumn(), parent);
+
+        Q_ASSERT(index.isValid());
+
+        const QString category = d->categoryForIndex(index);
+
+        if (lastCategory != category) {
+            lastCategory = category;
+            alreadyRemoved = 0;
+        }
 
-                return d->proxyModel->index(indexToMove, 0);
-            }
-            else
-            {
-                int lastCategoryLastRow = (d->categoriesIndexes[lastCategory].count() - 1) % elementsPerRow;
-                int indexToMove = current.row() - d->elementsInfo[current.row()].relativeOffsetToCategory;
-
-                if (d->forcedSelectionPosition >= lastCategoryLastRow)
-                {
-                    indexToMove -= 1;
-                }
-                else
-                {
-                    indexToMove -= qMin((lastCategoryLastRow - d->forcedSelectionPosition + 1), d->forcedSelectionPosition + elementsPerRow + 1);
-                }
+        Private::Block &block = d->blocks[category];
+        block.items.removeAt(i - block.firstIndex.row() - alreadyRemoved);
+        ++alreadyRemoved;
 
-                return d->proxyModel->index(indexToMove, 0);
-            }
+        if (!block.items.count()) {
+            listOfCategoriesMarkedForRemoval << category;
         }
 
-        case QAbstractItemView::MoveDown: {
-            if (d->elementsInfo[current.row()].relativeOffsetToCategory < (d->categoriesIndexes[theCategory].count() - 1 - ((d->categoriesIndexes[theCategory].count() - 1) % elementsPerRow)))
-            {
-                int indexToMove = current.row();
-                indexToMove += qMin(elementsPerRow, d->categoriesIndexes[theCategory].count() - 1 - d->elementsInfo[current.row()].relativeOffsetToCategory);
+        //TODO: assign less times
+        block.height = -1;
 
-                return d->proxyModel->index(indexToMove, 0);
-            }
-            else
-            {
-                int afterCategoryLastRow = qMin(elementsPerRow, d->categoriesIndexes[afterCategory].count());
-                int indexToMove = current.row() + (d->categoriesIndexes[theCategory].count() - d->elementsInfo[current.row()].relativeOffsetToCategory);
-
-                if (d->forcedSelectionPosition >= afterCategoryLastRow)
-                {
-                    indexToMove += afterCategoryLastRow - 1;
-                }
-                else
-                {
-                    indexToMove += qMin(d->forcedSelectionPosition, elementsPerRow);
-                }
+        viewport()->update();
+    }
 
-                return d->proxyModel->index(indexToMove, 0);
-            }
+    //BEGIN: update the items that are in quarantine in affected categories
+    {
+        const QModelIndex lastIndex = d->proxyModel->index(end, modelColumn(), parent);
+        const QString category = d->categoryForIndex(lastIndex);
+        Private::Block &block = d->blocks[category];
+        if (block.items.count() && start <= block.firstIndex.row() && end >= block.firstIndex.row()) {
+            block.firstIndex = d->proxyModel->index(end + 1, modelColumn(), parent);
         }
+        block.quarantineStart = block.firstIndex;
+    }
+    //END: update the items that are in quarantine in affected categories
 
-        case QAbstractItemView::MoveLeft:
-            if (layoutDirection() == Qt::RightToLeft)
-            {
-                if (!(d->elementsInfo[current.row() + 1].relativeOffsetToCategory % elementsPerRow))
-                    return current;
-
-                d->forcedSelectionPosition = d->elementsInfo[current.row() + 1].relativeOffsetToCategory % elementsPerRow;
-
-#if 0 //follow qt view behavior. lateral movements won't change visual row
-                if (d->forcedSelectionPosition < 0)
-                    d->forcedSelectionPosition = (d->categoriesIndexes[theCategory].count() - 1) % elementsPerRow;
-#endif
+    Q_FOREACH (const QString &category, listOfCategoriesMarkedForRemoval) {
+        d->blocks.remove(category);
+    }
 
-                return d->proxyModel->index(current.row() + 1, 0);
+    //BEGIN: mark as in quarantine those categories that are under the affected ones
+    {
+        //BEGIN: order for marking as alternate those blocks that are alternate
+        QList<Private::Block> blockList = d->blocks.values();
+        qSort(blockList.begin(), blockList.end(), Private::Block::lessThan);
+        QList<int> firstIndexesRows;
+        foreach (const Private::Block &block, blockList) {
+            firstIndexesRows << block.firstIndex.row();
+        }
+        //END: order for marking as alternate those blocks that are alternate
+        for (QHash<QString, Private::Block>::Iterator it = d->blocks.begin(); it != d->blocks.end(); ++it) {
+            Private::Block &block = *it;
+            if (block.firstIndex.row() > start) {
+                block.outOfQuarantine = false;
+                block.alternate = firstIndexesRows.indexOf(block.firstIndex.row()) % 2;
+            } else if (block.firstIndex.row() == start) {
+                block.alternate = firstIndexesRows.indexOf(block.firstIndex.row()) % 2;
             }
+        }
+    }
+    //END: mark as in quarantine those categories that are under the affected ones
 
-            if (!(d->elementsInfo[current.row()].relativeOffsetToCategory % elementsPerRow))
-                return current;
-
-            d->forcedSelectionPosition = d->elementsInfo[current.row() - 1].relativeOffsetToCategory % elementsPerRow;
-
-#if 0 //follow qt view behavior. lateral movements won't change visual row
-            if (d->forcedSelectionPosition < 0)
-                d->forcedSelectionPosition = (d->categoriesIndexes[theCategory].count() - 1) % elementsPerRow;
-#endif
+    QListView::rowsAboutToBeRemoved(parent, start, end);
+}
 
-            return d->proxyModel->index(current.row() - 1, 0);
+void KCategorizedView::updateGeometries()
+{
+    const int verticalOff = verticalOffset();
 
-        case QAbstractItemView::MoveRight:
-            if (layoutDirection() == Qt::RightToLeft)
-            {
-                if (!(d->elementsInfo[current.row()].relativeOffsetToCategory % elementsPerRow))
-                    return current;
+    QListView::updateGeometries();
 
-                d->forcedSelectionPosition = d->elementsInfo[current.row() - 1].relativeOffsetToCategory % elementsPerRow;
+    if (!d->isCategorized()) {
+        return;
+    }
 
-#if 0 //follow qt view behavior. lateral movements won't change visual row
-                if (d->forcedSelectionPosition < 0)
-                    d->forcedSelectionPosition = (d->categoriesIndexes[theCategory].count() - 1) % elementsPerRow;
-#endif
+    const int rowCount = d->proxyModel->rowCount();
+    if (!rowCount) {
+        verticalScrollBar()->setRange(0, 0);
+        return;
+    }
 
-                return d->proxyModel->index(current.row() - 1, 0);
-            }
+    const QModelIndex lastIndex = d->proxyModel->index(rowCount - 1, modelColumn(), rootIndex());
+    Q_ASSERT(lastIndex.isValid());
+    QRect lastItemRect = visualRect(lastIndex);
+
+    if (d->hasGrid()) {
+        lastItemRect.setSize(lastItemRect.size().expandedTo(gridSize()));
+    } else {
+        if (uniformItemSizes()) {
+            QSize itemSize = sizeHintForIndex(lastIndex);
+            itemSize.setHeight(itemSize.height() + spacing());
+            lastItemRect.setSize(itemSize);
+        } else {
+            QSize itemSize = sizeHintForIndex(lastIndex);
+            const QString category = d->categoryForIndex(lastIndex);
+            itemSize.setHeight(d->highestElementInLastRow(d->blocks[category]) + spacing());
+            lastItemRect.setSize(itemSize);
+        }
+    }
 
-            if (!(d->elementsInfo[current.row() + 1].relativeOffsetToCategory % elementsPerRow))
-                return current;
+    const int bottomRange = lastItemRect.bottomRight().y() + verticalOffset() - viewport()->height();
 
-            d->forcedSelectionPosition = d->elementsInfo[current.row() + 1].relativeOffsetToCategory % elementsPerRow;
+    verticalScrollBar()->setRange(0, bottomRange);
 
-#if 0 //follow qt view behavior. lateral movements won't change visual row
-            if (d->forcedSelectionPosition < 0)
-                d->forcedSelectionPosition = (d->categoriesIndexes[theCategory].count() - 1) % elementsPerRow;
-#endif
+    verticalScrollBar()->setValue(verticalOff);
 
-            return d->proxyModel->index(current.row() + 1, 0);
+    //TODO: also consider working with the horizontal scroll bar. since at this level I am not still
+    //      supporting "top to bottom" flow, there is no real problem. If I support that someday
+    //      (think how to draw categories ! crazy stuff !), we would have to take care of the
+    //      horizontal scroll bar too. In theory, as KCategorizedView has been designed, there is
+    //      no need of horizontal scroll bar.
+    horizontalScrollBar()->setRange(0, 0);
+}
 
-        default:
-            break;
-    }
+void KCategorizedView::currentChanged(const QModelIndex &current,
+                                      const QModelIndex &previous)
+{
+    QListView::currentChanged(current, previous);
+}
 
-    return QListView::moveCursor(cursorAction, modifiers);
+void KCategorizedView::dataChanged(const QModelIndex &topLeft,
+                                   const QModelIndex &bottomRight)
+{
+    QListView::dataChanged(topLeft, bottomRight);
 }
 
 void KCategorizedView::rowsInserted(const QModelIndex &parent,
